#ifndef _OBJ_KNOT_
#define _OBJ_KNOT_

#include "MathObject.h"


// rendering and admin
void	constructKnot			              ( void );	//
void	displayKnot			                  ( void );	//									
void	displayKnotQuaternionMap              ( void ); //
void	drawKnot			                  ( void );	//									
void	initKnotFirst			              ( MathObject *mathobjRef ); //
void	initKnot			                  ( void );	//
void    cleanupKnot                           ( void ); //

// computational
void	makeTangent								( void );	//
void    makeTangentDerivatives					( void ); //
void	computeParallelTransportFrame			( void );	//
void	computeFrenetFrame						( void );	//
void	renderFramedCurve						( double radius ); //
void    renderThickenedCurve					( double radius ); //
void    renderThickenedCurve2					( double radius ); //
void    drawFrames								( void ); //
void	drawTangDTangSpace						( void ); //
void    displayKnotQuaternionMap				( void ); //
void	displayQuaternionRings					( void ); //
void    renderFramedQuaternionCurve				( double radius ); //
void	renderFramedQuaternionCurve2			( double radius ); 
void	renderFramedQuaternionCurve3			( double radius, double *color, int flag_use_extern_color ); 
void    copy_QuatList							( void ); //
void    computeCurveQuaternionMap				( void ); //
void    computeParallelTransportQuaternionMap	( void ); //
void	computeParallelTransportQuaternionMap2	( void );
void    computeFrenetQuaternionMap				( void ); //
void    computeFrenetQuaternionMap2				( void ); //
void    computeFrenetQuaternionMap3				( void ); //
void    computeFrenetQuaternionMap4				( void ); //
void    computeFrenetQuaternionMap5				( void ); //
void    computeFrenetQuaternionMap6				( void ); //
void    computeFrenetQuaternionMap7				( void ); //
void    computeFrenetQuaternionMap8				( void ); //
void	makeFamilyOfQuaternions					( double theta, double *v, quaternion* qf );

void	getQuatComp								( int whichQuatComponent, quaternion* q, double* qvec);
void    drawQuaternionCurve						( double *color ); //
void    drawQuaternionCurve_forRings			( double *color ); //
void	drawQuaternionCurve						( int start, int end, double* color );
void	getSegmentColor							( int i, double *ccolor );

void    drawRings ();
void	drawQuaternionRingSpace();
#endif
